/*PRACTICA 1_7 DE OPENGL*/


/* Creada por Jose Mariscal Prieto.
	i72maprj@uco.es
*/


#include <fstream.h>
#include<windows.h>
#include<gl/Gl.h>
#include<gl/glut.h>
#include<gl/glu.h>
#include<math.h>
#include<iostream.h>
#define	ANCHOPANTA 400.0
#define ALTOPANTA 400.0  


//_________________________________________________________________



void myInit(void)
{
		glClearColor(1.0,1.0,1.0,0.0); //Selecciona el color de fondo
		glColor3f(1.0f, 0.0f, 0.0f);  //Color del pixel
		glPointSize(6.0);			//Tamao de los puntos
		glMatrixMode (GL_PROJECTION);
		glLoadIdentity();
		gluOrtho2D(0.0, ANCHOPANTA, 0.0, ALTOPANTA);
}



//_________________________________________________________________


//_______________________________________________________
// funcion que pinta el ajedrez

void ajedrez (int size)
{
// GLint x1, y1, x2, y2;
float b,n;
int i,j;
glClearColor(1.0, 1.0, 1.0, 0.0); // Color de fondo blanco para pruebas
glClear(GL_COLOR_BUFFER_BIT); //Limpia la ventana
n=0.6;
b=0.0;
	for(i=0;i<8; i++)
	{
		for(j=0;j<8;j++)
		{
//		glBegin(GL_POLYGON);
		// pintamos ahora el rectangulo.
	 // el color del rectangulo
		if ((i +j)%2 ==0) // si i+j es par
			{
			glColor3f(b, b, b);
			}
		else
			{
			glColor3f(n, n, n);
			}
		glRecti (i*size, j*size, i*size+size, j*size+size);
//		glEnd();
		}
	}
glFlush();
}


//_________________________________________________________________



void myDisplay(void) 
{
    ajedrez(50);
}


void main (int argc, char** argv)
{
  glutInit(&argc, argv); //Inicializa toolkit
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); //Selecciona el modo pantalla
  glutInitWindowSize(ANCHOPANTA,ALTOPANTA);	//Selecciona el tamao de la ventana
  glutInitWindowPosition(10, 10); //Posicion de la ventana en la pantalla
  glutCreateWindow("PRACTICA 1_6 DE  OPENGL");//Abre la ventana
  glutDisplayFunc(myDisplay); //Registra la funcin de redibujar
  myInit();
  glutMainLoop(); //Bucle continuo
}