// Practica2.3 de opengl


/* Creada por Jose Mariscal Prieto.
	i72maprj@uco.es
*/


#include<windows.h>
#include<gl/Gl.h>
#include<gl/glut.h>
#include<gl/glu.h>
#include<math.h>
#include<iostream.h>
#include<stdio.h>

void drawDot(int x , int y);
// Mi_inicio
void myInit(void);

// estructura para los puntos.
struct GLintPoint{
	int x;
	int y;
};

void myInit(void)
{
		glClearColor(1.0,1.0,0.0,0.0); //Selecciona el color de fondo
		glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
		glPointSize(1.0);			//Tamao de los puntos
		glMatrixMode (GL_PROJECTION);
		glLoadIdentity();
		gluOrtho2D(0.0, 400.0, 0.0, 420.0);
}

// funcion del aleatorio ramdom.

int ramdom(int m) // funcion aleatoria
{ 
 return rand() % m; 
} 


// mi ventana!
void myDisplay(void) // Mi_Ventana 
{

glClear(GL_COLOR_BUFFER_BIT); // clear screen

}

// funcion que dibuja los puntos.
void sierpinski(struct GLintPoint T[3])
{
int index = ramdom(3);
GLintPoint point = T[index]; // inicializa los putnos
drawDot(point.x, point.y);
for(int i=0; i<5000; i++)
        {
        index=ramdom(3);
        point.x=(point.x + T[index].x)/2;
        point.y=(point.y + T[index].y)/2;
        drawDot(point.x, point.y);
        }
glFlush();
}

// funcion que dibuja los puntos!
void drawDot(int x , int y)
{
glBegin(GL_POINTS);
glVertex2i(x,y);
glEnd();
glFlush(); //??? flushhh

}



/// __________________________
// funcion del raton

void raton(int button, int state, int x, int y)
{
static GLintPoint corner[3];
static int numCorners=0;


int Anchopantalla=420;
if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
	{
	corner[numCorners].x=x;
	corner[numCorners].y=Anchopantalla-y;
	numCorners++;
	if(numCorners==3)
		{
		sierpinski(corner);
		numCorners=0;
		}
		
	}
else if (button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
	{
	glClear(GL_COLOR_BUFFER_BIT);
	}
}

// MAIN
void main (int argc, char** argv)
{
glutInit(&argc, argv); //Inicializa toolkit
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); //Selecciona el modo pantalla
  glutInitWindowSize(400,420);	//Selecciona el tamao de la ventana
  glutInitWindowPosition(100, 150); //Posiciona la ventana en la pantalla
  glutCreateWindow("Practica 2.2");//Abre la ventana
  glutDisplayFunc(myDisplay); //Registra la funcin de redibujar
  myInit();
  glutMouseFunc(raton);  
  glutMainLoop(); //Bucle continuo
}