// Practica 3.5 de opengl

/* Creada por Jose Mariscal Prieto.
	i72maprj@uco.es
*/

#include<windows.h>
#include<gl/Gl.h>
#include<gl/glut.h>
#include<gl/glu.h>
#include<iostream.h>
#include<stdio.h>
#include<fstream.h>
#include<stdlib.h>


// definimos las funciones auxiliares
// para que el compilador no casque
void setWindow(float left, float right, float botton, float top);
void setViewport(int left , int right , int botton,int top);
void drawPolyLineFile(char *nomfich);

// Mi_inicio
void myInit(void)
{
  //		glClearColor(0.0,0.0,0.0,0.0); //Selecciona el color de fondo
  //		glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
  //		glPointSize(1.0);			//Tamao de los puntos
  //        glClear(GL_COLOR_BUFFER_BIT); // clear screen
  
}

void myDisplay(void)
{
  int NumFrames = 5;
  float cx = 168.0, cy = 128.0; //Centra la ventana
  float H = 320, W = 240.0f, aspect = 0.7f; //propiedades de la ventana
  setViewport(0,640,0,480);
  for (int frame = 0; frame < NumFrames; frame++) //para cada frame
    {
      glClear(GL_COLOR_BUFFER_BIT); //Limpia la pantalla
      W *= 0.7f; // reduce el ancho de ventana
      H = W * aspect; //mantiene la relacin de aspecto
      setWindow(cx - W, cx + W,cy - H,cy + H); //selcciona la siguiente ventana
      drawPolyLineFile("dino.dat"); //Dibuja el objeto
      glutSwapBuffers();
    }
  glFlush();
}

// mis funciones para el centrado de la pantalla
// y puerto de vista
void setWindow(float left, float right, float botton, float top)
{
  glClearColor(0.0,0.0,0.0,0.0); //Selecciona el color de fondo
  glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
  glPointSize(1.0);
  glMatrixMode(GL_PROJECTION); // proyectamos
  glLoadIdentity();
  gluOrtho2D(left, right, botton, top);
  
}

void setViewport(int left , int right , int botton,int top)
{
  glViewport(left, botton, right-left, top-botton);
}

// funcion para dibujar la polilinea...
void drawPolyLineFile(char *nomfich)
{
  
  fstream inStream;
  GLint numpolys, numLines, x, y; 	
  //  char c;
  cout << "Abre el fichero" ;
  inStream.open(nomfich, ios ::in); // abre el fichero
  
	if(inStream.fail() )
	  return;
	
	cout << "\nAhora pinta\n" ;
	//	glClear(GL_COLOR_BUFFER_BIT); // limpia la pantalla		
	inStream >> numpolys; 		//lee el nmero de polilneas   	
	
	for(int j= 0; j < numpolys; j++) //lee cada polilnea
	  {
	    inStream >> numLines;		 
	    
	    glBegin(GL_LINE_STRIP);	// dibuja la siguiente polilnea
	    
	    for (int i =0 ; i < numLines; i++)
	      {
		inStream >>x>>y;  //lee el siguiente par de x, y		   
		glVertex2i(x, y);
	      }
		// metemos retardo pa que mas o menos se vea!

		Sleep(50);
	    glEnd();
	  }
	
	//	glFlush();
	inStream.close();      
	
}

// MAIN
void main (int argc, char** argv)
{
  glutInit(&argc, argv); //Inicializa toolkit
// GLUT_DOUBLE utiliza el DOUBLE BUFFER
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB); //Selecciona el modo pantalla

  glutInitWindowSize(640,480);	//Selecciona el tamao de la ventana
  glutInitWindowPosition(100, 150); //Posiciona la ventana en la pantalla
  glutCreateWindow("Practica 3.5");//Abre la ventana
  //  myInit();
  
  glutDisplayFunc(myDisplay); //Registra la funcin de redibujar
  //  myInit();
  glutMainLoop(); //Bucle continuo
}
