// practica 4.4 

#include<windows.h>
#include<gl/Gl.h>
#include<gl/glut.h>
#include<gl/glu.h>
#include<iostream.h>
#include<stdio.h>
#include<fstream.h>
#include<math.h>
// define
#define GL_PI 3.1415f




// struct GLfloatPoint
struct GLfloatPoint
{
public:
  float x, y;
};

static GLfloat xRot=0.0f, yRot=0.0f;

// definimos las funciones auxiliares
// para que el compilador no casque

void Dibuja_Curvas();
// -----------------


void Dibuja_Curvas()
{
	GLfloat x,y; // Almacenar para coordenadas y angulos
	//Abrir fichero y almacenamiento de datos
	GLfloat a,b;
	double angulo=0.0f,dangulo;
	GLfloat centrox,centroy;
	GLfloat r; 

	
		// Clear the window with current clearing color
	glClear(GL_COLOR_BUFFER_BIT);

	// Save matrix state and do the rotation
	glPushMatrix();
	glRotatef(xRot, 1.0f, 0.0f, 0.0f);
	glRotatef(yRot, 0.0f, 1.0f, 0.0f);

	
	// LIMASON  
	a=25.0f;
	b=6.0f;
	dangulo=1/a;
	centrox=60.0f;
	centroy=-50.0f;
	x=(GLfloat)centrox+b+a;
	y=(GLfloat)centroy;
	// Set drawing color to red
	glColor3f(1.0f, 0.0f, 0.0f);
	glBegin(GL_LINE_STRIP);
	glVertex2f(x, y);	
	do
	{
		r=b+a*(GLfloat)cos(angulo);
		x=centrox+r*(GLfloat)cos(angulo);
		y=centroy+r*(GLfloat)sin(angulo);
		angulo+=dangulo;
		glVertex2f(x, y);
        }while((angulo)<2*GL_PI);
	glEnd();
	// ESPIRAL
        angulo=0;
	a=5;
        dangulo=1/a;
	centrox=0.0;
	centroy=0.0;
	x=centrox;
	y=centroy; 
	// Set drawing color to yellow
	glColor3f(1.0f, 1.0f, 0.0f);
	glBegin(GL_LINE_STRIP);
	glVertex2f(x, y);
        while((angulo)<2*GL_PI)
	{
                r=a*(GLfloat)angulo;
                x=centrox+r*(GLfloat)cos(angulo);
                y=centroy+r*(GLfloat)sin(angulo);
                angulo+=dangulo;
		glVertex2f(x, y);
	}
	glEnd();
		
	

		// TETRAFOLIO
        angulo=0;
	a=20;
        dangulo=1/a;
	centrox=-60;
	centroy=-50;
	x=centrox+a;
	y=centroy;
	// Set drawing color to green
	glColor3f(0.0f, 1.0f, 0.0f);
	glBegin(GL_LINE_STRIP);
	glVertex2f(x, y);
        while((angulo-1)<2*GL_PI)
	{

                r=a*(GLfloat)cos(2*angulo);
                x=centrox+r*(GLfloat)cos(angulo);
                y=centroy+r*(GLfloat)sin(angulo);
                angulo+=dangulo;
		glVertex2f(x, y);
	}
	glEnd();

		// CARDIODE
        angulo=0;
	a=15;
        dangulo=1/a;
	centrox=60;
	centroy=50;
	x=centrox+a*2;
	y=centroy;
	// Set drawing color to blue
	glColor3f(0.0f, 0.0f, 1.0f);
	glBegin(GL_LINE_STRIP);
	glVertex2f(x, y);
        while((angulo-1)<2*GL_PI)
	{
                r=a*(1+(GLfloat)cos(angulo));
                x=centrox+r*(GLfloat)cos(angulo);
                y=centroy+r*(GLfloat)sin(angulo);
                angulo+=dangulo;
		glVertex2f(x, y);
	}
	glEnd();
	// TRIFOLIO
    angulo=0;
	a=20;
    dangulo=1/a;
	centrox=-60;
	centroy=50;
	x=centrox+a;
	y=centroy;
	// Set drawing color to orange
	glColor3f(0.98f, 0.625f, 0.12f);
	glBegin(GL_LINE_STRIP);
	glVertex2f(x, y);
        while((angulo)<2*GL_PI)
	{
                r=a*((GLfloat)cos(3*angulo));
                x=centrox+r*(GLfloat)cos(angulo);
                y=centroy+r*(GLfloat)sin(angulo);
                angulo+=dangulo;
		glVertex2f(x, y);
	}
	glEnd();	

	//Mediante este for vamos a calcular cuales de los puntos estan
	//dentro del plano y cuales fuera.
	

	// Restore transformations
	glPopMatrix();

	// Flush drawing commands
	glFlush();
}

void myInit(void)
{
  glClearColor(1.0,1.0,1.0,0.0); //Selecciona el color de fondo
  glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
  glViewport(0,0,400,400); // el ancho de la pantalla mirar el main
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-100.0f, 110.0f, -100.0f, 110.0f, -100.0f, 100.0f);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

void myDisplay(void)
{
glClear(GL_COLOR_BUFFER_BIT); // clear screen
// pego();
Dibuja_Curvas();
// glFlush();
}


void mykeyboard(unsigned char tecla, int mouseX, int mouseY)
{
  switch(tecla)
    {
    case '8':
      xRot-=5.0f;
      if(xRot < -1.0f)
	{
	  xRot=355.0f;
	}
      Dibuja_Curvas();
      break;
    case '2':
      xRot+=5.0f;
      if(xRot > 356.0f)
	{
	  xRot=0.0f;
	}
      Dibuja_Curvas();
      break;
    case '4':
      yRot-=5.0f;
      if(yRot < -1.0f)
	{
	  yRot=355.0f;
	}
      Dibuja_Curvas();
      break;
    case '6':
      yRot+=5.0f;
      if(yRot > 356.0f)
	{
	  yRot=0.0f;
	}
      Dibuja_Curvas();
      break;
    }
}







// MAIN
void main (int argc, char** argv)
{
glutInit(&argc, argv); //Inicializa toolkit
glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); //Selecciona el modo pantalla
glutInitWindowSize(400,400);	//Selecciona el tamao de la ventana
glutInitWindowPosition(100, 150); //Posiciona la ventana en la pantalla
glutCreateWindow("Practica 4.4");//Abre la ventana
myInit();
glutDisplayFunc(myDisplay); //Registra la funcin de redibujar
glutKeyboardFunc(mykeyboard);
glutMainLoop(); //Bucle continuo
}
