// Practica 3.1 de opengl

/* Creada por Jose Mariscal Prieto.
	i72maprj@uco.es
*/

#include<windows.h>
#include<gl/Gl.h>
#include<gl/glut.h>
#include<gl/glu.h>
#include<iostream.h>
#include<stdio.h>
#include<math.h>
#define GL_PI 3.14159

// definimos las funciones auxiliares
// para que el compilador no casque
void setWindow(float left, float right, float botton, float top);
void setViewport(int left , int right , int botton,int top);

// Mi_inicio
void myInit(void)
{
  glClearColor(0.0,0.0,0.0,0.0); //Selecciona el color de fondo
  glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
  glPointSize(1.0);			//Tamao de los puntos
  

}

void myDisplay(void) // Mi_Ventana 
{
  setWindow(-5, 5, -0.3, 1.1);
  setViewport(0,640,0,480);
glClear(GL_COLOR_BUFFER_BIT); // clear screen
  glBegin(GL_LINE_STRIP);
  for(GLdouble x =-4.0; x < 4.0; x += 0.05)
    {
      GLfloat y =sin(GL_PI*x)/(GL_PI*x);
      glVertex2f(x,y);
    }
  glEnd();
// pintamos el eje de las X
  glColor3f(0.0f,0.0f,1.0f); // blue!
  glBegin(GL_LINE_STRIP);
  // las dos lineas!
  glVertex2f(-4.0,0.0);
  glVertex2f(4.0,0.0);
  glEnd();
// Dibuja eje Y
  glColor3f(0.0f,0.0f,1.0f); // blue!
  glBegin(GL_LINE_STRIP);
  glVertex2f( float (0.0), (float)(-0.2));
  glVertex2f( float (0.0), float (1.0));
  glEnd();
  glFlush(); //Enva toda la salida a la pantalla
}

// mis funciones para el centrado de la pantalla
// y puerto de vista
void setWindow(float left, float right, float botton, float top)
{
  glMatrixMode(GL_PROJECTION); // proyectamos
  glLoadIdentity();
  gluOrtho2D(left, right, botton, top);
  
}

void setViewport(int left , int right , int botton,int top)
{
  glViewport(left, botton, right-left, top-botton);
}

// MAIN
void main (int argc, char** argv)
{
  glutInit(&argc, argv); //Inicializa toolkit
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); //Selecciona el modo pantalla
  glutInitWindowSize(640,480);	//Selecciona el tamao de la ventana
  glutInitWindowPosition(100, 150); //Posiciona la ventana en la pantalla
  glutCreateWindow("Practica 3.1");//Abre la ventana
  myInit();
  
  glutDisplayFunc(myDisplay); //Registra la funcin de redibujar
//  myInit();
  glutMainLoop(); //Bucle continuo
}