// Practica 3.2 de opengl

/* Creada por Jose Mariscal Prieto.
	i72maprj@uco.es
*/

#include<windows.h>
#include<gl/Gl.h>
#include<gl/glut.h>
#include<gl/glu.h>
#include<iostream.h>
#include<stdio.h>
#include<fstream.h>

// #define GL_PI 3.141516

// definimos las funciones auxiliares
// para que el compilador no casque
void setWindow(float left, float right, float botton, float top);
void setViewport(int left , int right , int botton,int top);
void drawPolyLineFile(char *nomfich);

// Mi_inicio
void myInit(void)
{
  glClearColor(0.0,0.0,0.0,0.0); //Selecciona el color de fondo
  glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
  glPointSize(1.0);			//Tamao de los puntos
  //        glClear(GL_COLOR_BUFFER_BIT); // clear screen
  
}

void myDisplay(void) // Mi_Ventana 
{
  setWindow(0,640.0,0,480.0);
  
  //	setViewport(0,640,0,480);
  // esta linea de abajo tiene que ponerse aqui para que redibuje
  // correctamente.
  glClear(GL_COLOR_BUFFER_BIT); // clear screen
  
  for(int i=0; i< 5; i++)
    for(int j=0;j<5;j++)
      {
	glViewport(i*64,j*44,64,44);
	drawPolyLineFile("dino.dat");
      }
  
  	glFlush(); //Enva toda la salida a la pantalla
}

// mis funciones para el centrado de la pantalla
// y puerto de vista
void setWindow(float left, float right, float botton, float top)
{
  glClearColor(0.0,0.0,0.0,0.0); //Selecciona el color de fondo
  glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
  glPointSize(1.0);
  glMatrixMode(GL_PROJECTION); // proyectamos
  glLoadIdentity();
  gluOrtho2D(left, right, botton, top);
  
}

void setViewport(int left , int right , int botton,int top)
{
  glViewport(left, botton, right-left, top-botton);
}

// funcion para dibujar la polilinea...
void drawPolyLineFile(char *nomfich)
{
  fstream inStream;
  GLint numpolys, numLines, x, y; 	
  //  char c;
  cout << "Abre el fichero" ;
  inStream.open(nomfich, ios ::in); // abre el fichero
  
	if(inStream.fail() )
	  return;
	
	cout << "\nAhora pinta\n" ;
	//	glClear(GL_COLOR_BUFFER_BIT); // limpia la pantalla		
	inStream >> numpolys; 		//lee el nmero de polilneas   	
	
	for(int j= 0; j < numpolys; j++) //lee cada polilnea
	  {
	    inStream >> numLines;		 
	    
	    glBegin(GL_LINE_STRIP);	// dibuja la siguiente polilnea
	    
	    for (int i =0 ; i < numLines; i++)
	      {
		inStream >>x>>y;  //lee el siguiente par de x, y		   
		glVertex2i(x, y);
	      }
	    
	    glEnd();
	  }
	

	inStream.close();      
	
}

// resize window
void resizewindow(GLsizei W, GLsizei H)
{
if (1.6 > W/H)
	{
	setViewport(0, W, 0 , W/1.6);
	}
else
	{
	setViewport(0, H*1.6, 0 , H);
	}
}


// MAIN
void main (int argc, char** argv)
{
glutInit(&argc, argv); //Inicializa toolkit
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); //Selecciona el modo pantalla
  glutInitWindowSize(400,400);	//Selecciona el tamao de la ventana
  glutInitWindowPosition(100, 150); //Posiciona la ventana en la pantalla
  glutCreateWindow("Practica 3.2");//Abre la ventana
  myInit();
  glutDisplayFunc(myDisplay); //Registra la funcin de redibujar
   glutReshapeFunc(resizewindow);
  glutMainLoop(); //Bucle continuo
}
