// Practica 3.4 de opengl

/* Creada por Jose Mariscal Prieto.
	i72maprj@uco.es
*/

#include<windows.h>
#include<gl/Gl.h>
#include<gl/glut.h>
#include<gl/glu.h>
#include<iostream.h>
#include<stdio.h>
#include<fstream.h>


// definimos las funciones auxiliares
// para que el compilador no casque
void setWindow(float left, float right, float botton, float top);
void setViewport(int left , int right , int botton,int top);
void drawPolyLineFile(char *nomfich);

// Mi_inicio
void myInit(void)
{
  glClearColor(1.0,1.0,1.0,0.0); //Selecciona el color de fondo
  glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
  glPointSize(1.0);			//Tamao de los puntos
  glMatrixMode(GL_PROJECTION); // proyectamos
  glLoadIdentity();
//  gluOrtho2D(left, right, botton, top);
  
}

void myDisplay(void) // Mi_Ventana 
{
  
// setWindow(0,640.0,0,480.0);
	
  glClear(GL_COLOR_BUFFER_BIT); // clear screen

//dibuja ma o menos las lineas!!
// estoy hay que arreglarlo!!
glBegin(GL_LINE_STRIP);
glColor3f(0.0f,0.0f,1.0f);
glVertex2i(0,240);
glVertex2i(640,240);
glVertex2i(320,0);
glVertex2i(320,480);
glEnd();
// glFlush(); //???

/////----------------------------
// aqui empieza lo importante...

glColor3f(1.0f,0.0f,0.0f); // El color a dibujar

// Esquina inferior izquierda;
setWindow(0.0,640.0,0.0,480.0);
glViewport(0,0,320,240);
drawPolyLineFile("dino.dat");

//Esquina inferior derecha
setWindow(0.0,320,0.0,240.0);
glViewport(320,0,640,240);
drawPolyLineFile("dino.dat");

//Esquina superior izquierda
setWindow(-10.0,240.0,320.0,600.0);
glViewport(0,240,320,480);
drawPolyLineFile("dino.dat");

//Esquina superior derecha
setWindow(160.0,480.0,37.5,277.5);
glViewport(320,240,640,480);
drawPolyLineFile("dino.dat");


glFlush(); //Enva toda la salida a la pantalla
}

// mis funciones para el centrado de la pantalla
// y puerto de vista
void setWindow(float left, float right, float botton, float top)
{
  glClearColor(1.0,1.0,1.0,1.0); //Selecciona el color de fondo
  glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
  glPointSize(1.0);
  glMatrixMode(GL_PROJECTION); // proyectamos
  glLoadIdentity();
  gluOrtho2D(left, right, botton, top);
  
}

void setViewport(int left , int right , int botton,int top)
{
  glViewport(left, botton, right-left, top-botton);
}

// funcion para dibujar la polilinea...
void drawPolyLineFile(char *nomfich)
{
  fstream inStream;
  GLint numpolys, numLines, x, y; 	
  //  char c;
  cout << "Abre el fichero" ;
  inStream.open(nomfich, ios ::in); // abre el fichero
  
	if(inStream.fail() )
	  return;
	
	cout << "\nAhora pinta\n" ;
	//	glClear(GL_COLOR_BUFFER_BIT); // limpia la pantalla		
	inStream >> numpolys; 		//lee el nmero de polilneas   	
	
	for(int j= 0; j < numpolys; j++) //lee cada polilnea
	  {
	    inStream >> numLines;		 
	    
	    glBegin(GL_LINE_STRIP);	// dibuja la siguiente polilnea
	    
	    for (int i =0 ; i < numLines; i++)
	      {
		inStream >>x>>y;  //lee el siguiente par de x, y		   
		glVertex2i(x, y);
	      }
	    
	    glEnd();
	  }
	

	inStream.close();      
	
}



// MAIN
void main (int argc, char** argv)
{
glutInit(&argc, argv); //Inicializa toolkit
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); //Selecciona el modo pantalla
  glutInitWindowSize(640,480);	//Selecciona el tamao de la ventana
  glutInitWindowPosition(100, 150); //Posiciona la ventana en la pantalla
  glutCreateWindow("Dibujo de polilineas de un archivo");
  myInit();
  glutDisplayFunc(myDisplay); //Registra la funcin de redibujar
  myInit();
  glutMainLoop(); //Bucle continuo
}
