// practica 4.3.1 Estrella

#include<windows.h>
#include<gl/Gl.h>
#include<gl/glut.h>
#include<gl/glu.h>
#include<iostream.h>
#include<stdio.h>
#include<fstream.h>

// definimos las funciones auxiliares
// para que el compilador no casque
void setWindow(float left, float right, float botton, float top);
void setViewport(int left , int right , int botton,int top);
void drawPolyLineFileFloat(char *nomfich);


// -----------------
void myInit(void)
{
  glClearColor(0.0,0.0,0.0,0.0); //Selecciona el color de fondo
  glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
  glPointSize(1.0);			//Tamao de los puntos
  //        glClear(GL_COLOR_BUFFER_BIT); // clear screen
  
}

void myDisplay(void)
{

glClear(COLOR_BUFFER_BIT);
GLfloat angle 72.0;

setWindow(-227.077f,252.922f,-167.49f,192.505f);
setViewport(0,640,0,480);
for(int cont=0; cont <5; cont ++)
        {
        // implementar con la clase canvas.
        if(cont==0)
                {
                glColor3f(0.0f,1.0f,0.0f)
                }
        else
                {
                glColor3f(1.0f,0.0f,0.0f)
                drawPolyLineFileFloat("estrella.dat");
                glrotate(angle, 0,0,0,0,1.0);
                }
// dibuja el objeto a repetir mediante rotacion
setWindow(-120.0f, 117.4f, -18.0f,160.3f);
setViewport(0,180,345,480);
drawPolyLineFileFloat("estrella.dat");
// dibuja el rectangulo
glColor3f(0.0f,0.0f,1.0f);
setWindow(0.0f,640.0f,0.0f,480f);
setViewport(0,640.0f,0.0f,480.0f);
GlBegin(GL_LINE_STRIP);
glVertex2d(0,345);
glVertex2d(180,345);
glVertex2d(180,480);
glVertex2d(0,480);
glVertex2d(0,345);
glEnd();
}


// funcion para dibujar la polilinea de floats...
void drawPolyLineFileFloat(char *nomfich)
{
  fstream inStream;
  GLint numpolys, numLines;
  GLfloat x, y;
  //  char c;
  cout << "Abre el fichero" ;
  inStream.open(nomfich, ios ::in); // abre el fichero

        if(inStream.fail() )
          return;

        cout << "\nAhora pinta\n" ;
        //      glClear(GL_COLOR_BUFFER_BIT); // limpia la pantalla
        inStream >> numpolys;           //lee el nmero de polilneas

        for(int j= 0; j < numpolys; j++) //lee cada polilnea
          {
            inStream >> numLines;

            glBegin(GL_LINE_STRIP);     // dibuja la siguiente polilnea

            for (int i =0 ; i < numLines; i++)
              {
                inStream >>x>>y;  //lee el siguiente par de x, y
                glVertex2f(x, y);
              }

            glEnd();
          }


        inStream.close();

}


// mis funciones para el centrado de la pantalla
// y puerto de vista
void setWindow(float left, float right, float botton, float top)
{
  glClearColor(0.0,0.0,0.0,0.0); //Selecciona el color de fondo
  glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
  glPointSize(1.0);
  glMatrixMode(GL_PROJECTION); // proyectamos
  glLoadIdentity();
  gluOrtho2D(left, right, botton, top);
  
}

void setViewport(int left , int right , int botton,int top)
{
  glViewport(left, botton, right-left, top-botton);
}

// resize window
void resizewindow(GLsizei W, GLsizei H)
{
if (1.6 > W/H)
	{
	setViewport(0, W, 0 , W/1.6);
	}
else
	{
	setViewport(0, H*1.6, 0 , H);
	}
}


// MAIN
void main (int argc, char** argv)
{
glutInit(&argc, argv); //Inicializa toolkit
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); //Selecciona el modo pantalla
  glutInitWindowSize(400,400);	//Selecciona el tamao de la ventana
  glutInitWindowPosition(100, 150); //Posiciona la ventana en la pantalla
  glutCreateWindow("Practica 4.3.1");//Abre la ventana
  myInit();
  glutDisplayFunc(myDisplay); //Registra la funcin de redibujar
  glutReshapeFunc(resizewindow);
  glutMainLoop(); //Bucle continuo
}
